module lut_3_5(out, a, b, clk);
	input [1:0] a;
	input [2:0] b;
	reg [2:0] inter;
	wire [3:0] bmod;
	input clk;
	output wire [2:0] out;

	assign bmod = 2*inter[0] + 4*inter[1] + 3*inter[2];
	mod_5_9 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 5 + b - a;
		end 
	end
endmodule

module mod_5_9 (in, out);
	input [3:0] in;
	output reg [2:0] out;
	always @ (in)
	begin
		if (in < 3'd5)
		begin
			out = in;
		end
		else
		begin
			out = in - 3'd5;
		end
	end
endmodule

module lut_3_7(out, a, b, clk);
	input [1:0] a;
	input [2:0] b;
	reg [2:0] inter;
	wire [3:0] bmod;
	input clk;
	output wire [2:0] out;

	assign bmod = 5*inter[0] + 3*inter[1] + 6*inter[2];
	mod_7_14 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 7 + b - a;
		end 
	end
endmodule

module mod_7_14 (in, out);
	input [3:0] in;
	output reg [2:0] out;
	always @ (in)
	begin
		if (in < 3'd7)
		begin
			out = in;
		end
		else if (in < 4'd14)
		begin
			out = in - 3'd7;
		end
		else
		begin
			out = in - 4'd14;
		end
	end
endmodule

module lut_3_11(out, a, b, clk);
	input [1:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [4:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 4*inter[0] + 8*inter[1] + 5*inter[2] + 10*inter[3];
	mod_11_27 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 11 + b - a;
		end 
	end
endmodule

module mod_11_27 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd11)
		begin
			out = in;
		end
		else if (in < 5'd22)
		begin
			out = in - 4'd11;
		end
		else
		begin
			out = in - 5'd22;
		end
	end
endmodule

module lut_3_13(out, a, b, clk);
	input [1:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 9*inter[0] + 5*inter[1] + 10*inter[2] + 7*inter[3];
	mod_13_31 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 13 + b - a;
		end 
	end
endmodule

module mod_13_31 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd13)
		begin
			out = in;
		end
		else if (in < 5'd26)
		begin
			out = in - 4'd13;
		end
		else
		begin
			out = in - 5'd26;
		end
	end
endmodule

module lut_3_17(out, a, b, clk);
	input [1:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 6*inter[0] + 12*inter[1] + 7*inter[2] + 14*inter[3] + 11*inter[4];
	mod_17_50 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 17 + b - a;
		end 
	end
endmodule

module mod_17_50 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else
		begin
			out = in - 6'd34;
		end
	end
endmodule

module lut_3_23(out, a, b, clk);
	input [1:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 8*inter[0] + 16*inter[1] + 9*inter[2] + 18*inter[3] + 13*inter[4];
	mod_23_64 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_64 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else
		begin
			out = in - 6'd46;
		end
	end
endmodule

module lut_3_31(out, a, b, clk);
	input [1:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 21*inter[0] + 11*inter[1] + 22*inter[2] + 13*inter[3] + 26*inter[4];
	mod_31_93 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module mod_31_93 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd31)
		begin
			out = in;
		end
		else if (in < 6'd62)
		begin
			out = in - 5'd31;
		end
		else if (in < 7'd93)
		begin
			out = in - 6'd62;
		end
		else
		begin
			out = in - 7'd93;
		end
	end
endmodule

module lut_5_7(out, a, b, clk);
	input [2:0] a;
	input [2:0] b;
	reg [2:0] inter;
	wire [3:0] bmod;
	input clk;
	output wire [2:0] out;

	assign bmod = 3*inter[0] + 6*inter[1] + 5*inter[2];
	mod_7_14 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 7 + b - a;
		end 
	end
endmodule

module lut_5_11(out, a, b, clk);
	input [2:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [4:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 9*inter[0] + 7*inter[1] + 3*inter[2] + 6*inter[3];
	mod_11_25 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 11 + b - a;
		end 
	end
endmodule

module mod_11_25 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd11)
		begin
			out = in;
		end
		else if (in < 5'd22)
		begin
			out = in - 4'd11;
		end
		else
		begin
			out = in - 5'd22;
		end
	end
endmodule

module lut_5_13(out, a, b, clk);
	input [2:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [4:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 8*inter[0] + 3*inter[1] + 6*inter[2] + 12*inter[3];
	mod_13_29 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 13 + b - a;
		end 
	end
endmodule

module mod_13_29 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd13)
		begin
			out = in;
		end
		else if (in < 5'd26)
		begin
			out = in - 4'd13;
		end
		else
		begin
			out = in - 5'd26;
		end
	end
endmodule

module lut_5_17(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 7*inter[0] + 14*inter[1] + 11*inter[2] + 5*inter[3] + 10*inter[4];
	mod_17_47 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 17 + b - a;
		end 
	end
endmodule

module mod_17_47 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else
		begin
			out = in - 6'd34;
		end
	end
endmodule

module lut_5_23(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 14*inter[0] + 5*inter[1] + 10*inter[2] + 20*inter[3] + 17*inter[4];
	mod_23_66 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_66 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else
		begin
			out = in - 6'd46;
		end
	end
endmodule

module lut_5_31(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 25*inter[0] + 19*inter[1] + 7*inter[2] + 14*inter[3] + 28*inter[4];
	mod_31_93 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module lut_7_11(out, a, b, clk);
	input [2:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 8*inter[0] + 5*inter[1] + 10*inter[2] + 9*inter[3];
	mod_11_32 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 11 + b - a;
		end 
	end
endmodule

module mod_11_32 (in, out);
	input [5:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd11)
		begin
			out = in;
		end
		else if (in < 5'd22)
		begin
			out = in - 4'd11;
		end
		else
		begin
			out = in - 5'd22;
		end
	end
endmodule

module lut_7_13(out, a, b, clk);
	input [2:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [4:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 2*inter[0] + 4*inter[1] + 8*inter[2] + 3*inter[3];
	mod_13_17 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 13 + b - a;
		end 
	end
endmodule

module mod_13_17 (in, out);
	input [4:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd13)
		begin
			out = in;
		end
		else
		begin
			out = in - 4'd13;
		end
	end
endmodule

module lut_7_17(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 5*inter[0] + 10*inter[1] + 3*inter[2] + 6*inter[3] + 12*inter[4];
	mod_17_36 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 17 + b - a;
		end 
	end
endmodule

module mod_17_36 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else
		begin
			out = in - 6'd34;
		end
	end
endmodule

module lut_7_23(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 10*inter[0] + 20*inter[1] + 17*inter[2] + 11*inter[3] + 22*inter[4];
	mod_23_80 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_80 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else if (in < 7'd69)
		begin
			out = in - 6'd46;
		end
		else
		begin
			out = in - 7'd69;
		end
	end
endmodule

module lut_7_31(out, a, b, clk);
	input [2:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 9*inter[0] + 18*inter[1] + 5*inter[2] + 10*inter[3] + 20*inter[4];
	mod_31_62 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module mod_31_62 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd31)
		begin
			out = in;
		end
		else if (in < 6'd62)
		begin
			out = in - 5'd31;
		end
		else
		begin
			out = in - 6'd62;
		end
	end
endmodule

module lut_11_13(out, a, b, clk);
	input [3:0] a;
	input [3:0] b;
	reg [3:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [3:0] out;

	assign bmod = 6*inter[0] + 12*inter[1] + 11*inter[2] + 9*inter[3];
	mod_13_38 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 13 + b - a;
		end 
	end
endmodule

module mod_13_38 (in, out);
	input [5:0] in;
	output reg [3:0] out;
	always @ (in)
	begin
		if (in < 4'd13)
		begin
			out = in;
		end
		else if (in < 5'd26)
		begin
			out = in - 4'd13;
		end
		else
		begin
			out = in - 5'd26;
		end
	end
endmodule

module lut_11_17(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 14*inter[0] + 11*inter[1] + 5*inter[2] + 10*inter[3] + 3*inter[4];
	mod_17_43 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 17 + b - a;
		end 
	end
endmodule

module mod_17_43 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else
		begin
			out = in - 6'd34;
		end
	end
endmodule

module lut_11_23(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 21*inter[0] + 19*inter[1] + 15*inter[2] + 7*inter[3] + 14*inter[4];
	mod_23_76 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_76 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else if (in < 7'd69)
		begin
			out = in - 6'd46;
		end
		else
		begin
			out = in - 7'd69;
		end
	end
endmodule

module lut_11_31(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 17*inter[0] + 3*inter[1] + 6*inter[2] + 12*inter[3] + 24*inter[4];
	mod_31_62 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module lut_13_17(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 4*inter[0] + 8*inter[1] + 16*inter[2] + 15*inter[3] + 13*inter[4];
	mod_17_56 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 17 + b - a;
		end 
	end
endmodule

module mod_17_56 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd17)
		begin
			out = in;
		end
		else if (in < 6'd34)
		begin
			out = in - 5'd17;
		end
		else if (in < 6'd51)
		begin
			out = in - 6'd34;
		end
		else
		begin
			out = in - 6'd51;
		end
	end
endmodule

module lut_13_23(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 16*inter[0] + 9*inter[1] + 18*inter[2] + 13*inter[3] + 3*inter[4];
	mod_23_59 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_59 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else
		begin
			out = in - 6'd46;
		end
	end
endmodule

module lut_13_31(out, a, b, clk);
	input [3:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 12*inter[0] + 24*inter[1] + 17*inter[2] + 3*inter[3] + 6*inter[4];
	mod_31_62 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module lut_17_23(out, a, b, clk);
	input [4:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [5:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 19*inter[0] + 15*inter[1] + 7*inter[2] + 14*inter[3] + 5*inter[4];
	mod_23_60 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 23 + b - a;
		end 
	end
endmodule

module mod_23_60 (in, out);
	input [5:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd23)
		begin
			out = in;
		end
		else if (in < 6'd46)
		begin
			out = in - 5'd23;
		end
		else
		begin
			out = in - 6'd46;
		end
	end
endmodule

module lut_17_31(out, a, b, clk);
	input [4:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 11*inter[0] + 22*inter[1] + 13*inter[2] + 26*inter[3] + 21*inter[4];
	mod_31_93 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module lut_23_31(out, a, b, clk);
	input [4:0] a;
	input [4:0] b;
	reg [4:0] inter;
	wire [6:0] bmod;
	input clk;
	output wire [4:0] out;

	assign bmod = 27*inter[0] + 23*inter[1] + 15*inter[2] + 30*inter[3] + 29*inter[4];
	mod_31_124 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 31 + b - a;
		end 
	end
endmodule

module mod_31_124 (in, out);
	input [6:0] in;
	output reg [4:0] out;
	always @ (in)
	begin
		if (in < 5'd31)
		begin
			out = in;
		end
		else if (in < 6'd62)
		begin
			out = in - 5'd31;
		end
		else if (in < 7'd93)
		begin
			out = in - 6'd62;
		end
		else if (in < 7'd124)
		begin
			out = in - 7'd93;
		end
		else
		begin
			out = in - 7'd124;
		end
	end
endmodule

module mult5(out, data);

	input [2:0] data;
	output reg [3:0] out;
	
	always @ (data) 
	begin
		out <= 3*data;
	end
endmodule

module mult7(out, data);

	input [2:0] data;
	output reg [6:0] out;
	
	always @ (data) 
	begin
		out <= 15*data;
	end
endmodule

module mult11(out, data);

	input [3:0] data;
	output reg [10:0] out;
	
	always @ (data) 
	begin
		out <= 105*data;
	end
endmodule

module mult13(out, data);

	input [3:0] data;
	output reg [13:0] out;
	
	always @ (data) 
	begin
		out <= 1155*data;
	end
endmodule

module mult17(out, data);

	input [4:0] data;
	output reg [17:0] out;
	
	always @ (data) 
	begin
		out <= 15015*data;
	end
endmodule

module mult23(out, data);

	input [4:0] data;
	output reg [22:0] out;
	
	always @ (data) 
	begin
		out <= 255255*data;
	end
endmodule

module mult31(out, data);

	input [4:0] data;
	output reg [27:0] out;
	
	always @ (data) 
	begin
		out <= 5870865*data;
	end
endmodule

module register(res, x, clk);
	parameter WIDTH=3;
	input  clk;
	input  [WIDTH-1:0] x;
	output reg [WIDTH-1:0] res;

	always @ (posedge clk)
	begin
		res <= x;
	end
endmodule

module adder(result, dataa, datab, clk);
	parameter WIDTH_A=3;
	parameter WIDTH_B=8;
	parameter WIDTH_C=8;
	input clk;
	input  [WIDTH_A - 1:0] dataa;
	input  [WIDTH_B - 1:0] datab;
	output reg [WIDTH_C:0] result;

	always @ (posedge clk) 
	begin 
		result <= dataa + datab;
	end
endmodule

module mix_rdx (res1, res2, res3, res4, res5, res6, res7, res8, x1, x2, x3, x4, x5, x6, x7, x8, clk); 

	input clk;
	input	[1:0] x1;
	input	[2:0] x2;
	input	[2:0] x3;
	input	[3:0] x4;
	input	[3:0] x5;
	input	[4:0] x6;
	input	[4:0] x7;
	input	[4:0] x8;

	output	[1:0] res1;
	output	[2:0] res2;
	output	[2:0] res3;
	output	[3:0] res4;
	output	[3:0] res5;
	output	[4:0] res6;
	output	[4:0] res7;
	output	[4:0] res8;
	
	wire [4:0] out_17_31, out_13_31, out_11_31, out_7_31, out_5_31, out_3_31;
	wire [4:0] out_13_23, out_11_23, out_7_23, out_5_23, out_3_23;
	wire [4:0] out_11_17, out_7_17, out_5_17, out_3_17;
	wire [3:0] out_7_13, out_5_13, out_3_13;
	wire [3:0] out_5_11, out_3_11;
	wire [2:0] out_3_7;

	assign res1 = x1;

	lut_3_5 l3_5 (res2, x1, x2, clk);
	lut_3_7 l3_7 (out_3_7, x1, x3, clk);
	lut_3_11 l3_11 (out_3_11, x1, x4, clk);
	lut_3_13 l3_13 (out_3_13, x1, x5, clk);
	lut_3_17 l3_17 (out_3_17, x1, x6, clk);
	lut_3_23 l3_23 (out_3_23, x1, x7, clk);
	lut_3_31 l3_31 (out_3_31, x1, x8, clk);
	lut_5_7 l5_7 (res3, res2, out_3_7, clk);
	lut_5_11 l5_11 (out_5_11, res2, out_3_11, clk);
	lut_5_13 l5_13 (out_5_13, res2, out_3_13, clk);
	lut_5_17 l5_17 (out_5_17, res2, out_3_17, clk);
	lut_5_23 l5_23 (out_5_23, res2, out_3_23, clk);
	lut_5_31 l5_31 (out_5_31, res2, out_3_31, clk);
	lut_7_11 l7_11 (res4, res3, out_5_11, clk);
	lut_7_13 l7_13 (out_7_13, res3, out_5_13, clk);
	lut_7_17 l7_17 (out_7_17, res3, out_5_17, clk);
	lut_7_23 l7_23 (out_7_23, res3, out_5_23, clk);
	lut_7_31 l7_31 (out_7_31, res3, out_5_31, clk);
	lut_11_13 l11_13 (res5, res4, out_7_13, clk);
	lut_11_17 l11_17 (out_11_17, res4, out_7_17, clk);
	lut_11_23 l11_23 (out_11_23, res4, out_7_23, clk);
	lut_11_31 l11_31 (out_11_31, res4, out_7_31, clk);
	lut_13_17 l13_17 (res6, res5, out_11_17, clk);
	lut_13_23 l13_23 (out_13_23, res5, out_11_23, clk);
	lut_13_31 l13_31 (out_13_31, res5, out_11_31, clk);
	lut_17_23 l17_23 (res7, res6, out_13_23, clk);
	lut_17_31 l17_31 (out_17_31, res6, out_13_31, clk);
	lut_23_31 l23_31 (res8, res7, out_17_31, clk);
endmodule

module par_adder(result, x1, x2, x3, x4, x5, x6, x7, x8, clk);

	input clk;
	input [1:0] x1;
	input [3:0] x2;
	input [6:0] x3;
	input [10:0] x4;
	input [13:0] x5;
	input [17:0] x6;
	input [22:0] x7;
	input [27:0] x8;
	output [27:0] result;
	wire [1:0] reg1out;
	wire [4:0] add1out;
	wire [7:0] add2out;
	wire [11:0] add3out;
	wire [14:0] add4out;
	wire [18:0] add5out;
	wire [23:0] add6out;

	register #(.WIDTH(2)) reg1 (reg1out, x1, clk);
	adder #(.WIDTH_A(2), .WIDTH_B(4), .WIDTH_C(4)) add1 (add1out, reg1out, x2, clk);
	adder #(.WIDTH_A(5), .WIDTH_B(7), .WIDTH_C(7)) add2 (add2out, add1out, x3, clk);
	adder #(.WIDTH_A(8), .WIDTH_B(11), .WIDTH_C(11)) add3 (add3out, add2out, x4, clk);
	adder #(.WIDTH_A(12), .WIDTH_B(14), .WIDTH_C(14)) add4 (add4out, add3out, x5, clk);
	adder #(.WIDTH_A(15), .WIDTH_B(18), .WIDTH_C(18)) add5 (add5out, add4out, x6, clk);
	adder #(.WIDTH_A(19), .WIDTH_B(23), .WIDTH_C(23)) add6 (add6out, add5out, x7, clk);
	adder #(.WIDTH_A(24), .WIDTH_B(28), .WIDTH_C(27)) add7 (result, add6out, x8, clk);
endmodule

module reverse_conv(result, x1, x2, x3, x4, x5, x6, x7, x8, clk);

	input clk;
	input [1:0] x1;
	input [2:0] x2;
	input [2:0] x3;
	input [3:0] x4;
	input [3:0] x5;
	input [4:0] x6;
	input [4:0] x7;
	input [4:0] x8;
	output [27:0] result;

	wire [1:0] mix_rdx1out;
	wire [2:0] mix_rdx2out;
	wire [2:0] mix_rdx3out;
	wire [3:0] mix_rdx4out;
	wire [3:0] mix_rdx5out;
	wire [4:0] mix_rdx6out;
	wire [4:0] mix_rdx7out;
	wire [4:0] mix_rdx8out;

	wire [3:0] mult5out;
	wire [6:0] mult7out;
	wire [10:0] mult11out;
	wire [13:0] mult13out;
	wire [17:0] mult17out;
	wire [22:0] mult23out;
	wire [27:0] mult31out;
	mix_rdx mix1 (mix_rdx1out, mix_rdx2out, mix_rdx3out, mix_rdx4out, mix_rdx5out, mix_rdx6out, mix_rdx7out, mix_rdx8out, x1, x2, x3, x4, x5, x6, x7, x8, clk);
	mult5 m5 (mult5out, mix_rdx2out);
	mult7 m7 (mult7out, mix_rdx3out);
	mult11 m11 (mult11out, mix_rdx4out);
	mult13 m13 (mult13out, mix_rdx5out);
	mult17 m17 (mult17out, mix_rdx6out);
	mult23 m23 (mult23out, mix_rdx7out);
	mult31 m31 (mult31out, mix_rdx8out);
	par_adder pa (result, mix_rdx1out, mult5out, mult7out, mult11out, mult13out, mult17out, mult23out, mult31out, clk);

endmodule

module atest_bench();
	reg clk;
	reg [1:0] in0;  // Module: 3
	reg [2:0] in1;  // Module: 5
	reg [2:0] in2;  // Module: 7
	reg [3:0] in3;  // Module: 11
	reg [3:0] in4;  // Module: 13
	reg [4:0] in5;  // Module: 17
	reg [4:0] in6;  // Module: 23
	reg [4:0] in7;  // Module: 31
	wire [27:0] out; // Max value (not included): 181996815

	integer l;
	reg dummy;
	integer i0, prev;

	reverse_conv r1 (out, in0, in1, in2, in3, in4, in5, in6, in7, clk);

	// One test. Ticks: 8
	initial
	begin
		i0 = 44726569;
		clk = 0;
		#1 dummy = 1;
		in0 = i0%3;
		in1 = i0%5;
		in2 = i0%7;
		in3 = i0%11;
		in4 = i0%13;
		in5 = i0%17;
		in6 = i0%23;
		in7 = i0%31;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		$display ("!!! Res=(%d) Expect=(%d)", out, i0);
		l = out;
		if (l != i0)
		begin
			$display ("!!! Error (%d, %d)!!!", i0, l);
		end
	end
endmodule
