module lut_511_512(out, a, b, clk);
	input [8:0] a;
	input [8:0] b;
	reg [8:0] inter;
	wire [12:0] bmod;
	input clk;
	output wire [8:0] out;

	assign bmod = 511*inter[0] + 510*inter[1] + 508*inter[2] + 504*inter[3] + 496*inter[4] + 480*inter[5] + 448*inter[6] + 384*inter[7] + 256*inter[8];
	mod_512_4097 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 512 + b - a;
		end 
	end
endmodule

module mod_512_4097 (in, out);
	input [12:0] in;
	output reg [8:0] out;
	always @ (in)
	begin
		if (in < 10'd512)
		begin
			out = in;
		end
		else if (in < 11'd1024)
		begin
			out = in - 10'd512;
		end
		else if (in < 11'd1536)
		begin
			out = in - 11'd1024;
		end
		else if (in < 12'd2048)
		begin
			out = in - 11'd1536;
		end
		else if (in < 12'd2560)
		begin
			out = in - 12'd2048;
		end
		else if (in < 12'd3072)
		begin
			out = in - 12'd2560;
		end
		else if (in < 12'd3584)
		begin
			out = in - 12'd3072;
		end
		else if (in < 13'd4096)
		begin
			out = in - 12'd3584;
		end
		else
		begin
			out = in - 13'd4096;
		end
	end
endmodule

module lut_511_513(out, a, b, clk);
	input [8:0] a;
	input [9:0] b;
	reg [9:0] inter;
	wire [12:0] bmod;
	input clk;
	output wire [9:0] out;

	assign bmod = 256*inter[0] + 512*inter[1] + 511*inter[2] + 509*inter[3] + 505*inter[4] + 497*inter[5] + 481*inter[6] + 449*inter[7] + 385*inter[8] + 257*inter[9];
	mod_513_4362 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 513 + b - a;
		end 
	end
endmodule

module mod_513_4362 (in, out);
	input [12:0] in;
	output reg [9:0] out;
	always @ (in)
	begin
		if (in < 10'd513)
		begin
			out = in;
		end
		else if (in < 11'd1026)
		begin
			out = in - 10'd513;
		end
		else if (in < 11'd1539)
		begin
			out = in - 11'd1026;
		end
		else if (in < 12'd2052)
		begin
			out = in - 11'd1539;
		end
		else if (in < 12'd2565)
		begin
			out = in - 12'd2052;
		end
		else if (in < 12'd3078)
		begin
			out = in - 12'd2565;
		end
		else if (in < 12'd3591)
		begin
			out = in - 12'd3078;
		end
		else if (in < 13'd4104)
		begin
			out = in - 12'd3591;
		end
		else
		begin
			out = in - 13'd4104;
		end
	end
endmodule

module lut_512_513(out, a, b, clk);
	input [8:0] a;
	input [9:0] b;
	reg [9:0] inter;
	wire [12:0] bmod;
	input clk;
	output wire [9:0] out;

	assign bmod = 512*inter[0] + 511*inter[1] + 509*inter[2] + 505*inter[3] + 497*inter[4] + 481*inter[5] + 449*inter[6] + 385*inter[7] + 257*inter[8] + 1*inter[9];
	mod_513_4107 mod (bmod, out);
	
	always @ (posedge clk) 
	begin 

		if (b >= a)
		begin 
			inter = b - a;
		end 
		else 
		begin 
			inter = 513 + b - a;
		end 
	end
endmodule

module mod_513_4107 (in, out);
	input [12:0] in;
	output reg [9:0] out;
	always @ (in)
	begin
		if (in < 10'd513)
		begin
			out = in;
		end
		else if (in < 11'd1026)
		begin
			out = in - 10'd513;
		end
		else if (in < 11'd1539)
		begin
			out = in - 11'd1026;
		end
		else if (in < 12'd2052)
		begin
			out = in - 11'd1539;
		end
		else if (in < 12'd2565)
		begin
			out = in - 12'd2052;
		end
		else if (in < 12'd3078)
		begin
			out = in - 12'd2565;
		end
		else if (in < 12'd3591)
		begin
			out = in - 12'd3078;
		end
		else if (in < 13'd4104)
		begin
			out = in - 12'd3591;
		end
		else
		begin
			out = in - 13'd4104;
		end
	end
endmodule

module mult512(out, data);

	input [8:0] data;
	output reg [17:0] out;
	
	always @ (data) 
	begin
		out <= 511*data;
	end
endmodule

module mult513(out, data);

	input [9:0] data;
	output reg [26:0] out;
	
	always @ (data) 
	begin
		out <= 261632*data;
	end
endmodule

module register(res, x, clk);
	parameter WIDTH=3;
	input  clk;
	input  [WIDTH-1:0] x;
	output reg [WIDTH-1:0] res;

	always @ (posedge clk)
	begin
		res <= x;
	end
endmodule

module adder(result, dataa, datab, clk);
	parameter WIDTH_A=3;
	parameter WIDTH_B=8;
	parameter WIDTH_C=8;
	input clk;
	input  [WIDTH_A - 1:0] dataa;
	input  [WIDTH_B - 1:0] datab;
	output reg [WIDTH_C:0] result;

	always @ (posedge clk) 
	begin 
		result <= dataa + datab;
	end
endmodule

module mix_rdx (res1, res2, res3, x1, x2, x3, clk); 

	input clk;
	input	[8:0] x1;
	input	[8:0] x2;
	input	[9:0] x3;

	output	[8:0] res1;
	output	[8:0] res2;
	output	[9:0] res3;
	
	wire [9:0] out_511_513;

	assign res1 = x1;

	lut_511_512 l511_512 (res2, x1, x2, clk);
	lut_511_513 l511_513 (out_511_513, x1, x3, clk);
	lut_512_513 l512_513 (res3, res2, out_511_513, clk);
endmodule

module par_adder(result, x1, x2, x3, clk);

	input clk;
	input [8:0] x1;
	input [17:0] x2;
	input [26:0] x3;
	output [26:0] result;
	wire [8:0] reg1out;
	wire [18:0] add1out;

	register #(.WIDTH(9)) reg1 (reg1out, x1, clk);
	adder #(.WIDTH_A(9), .WIDTH_B(18), .WIDTH_C(18)) add1 (add1out, reg1out, x2, clk);
	adder #(.WIDTH_A(19), .WIDTH_B(27), .WIDTH_C(26)) add2 (result, add1out, x3, clk);
endmodule

module reverse_conv(result, x1, x2, x3, clk);

	input clk;
	input [8:0] x1;
	input [8:0] x2;
	input [9:0] x3;
	output [26:0] result;

	wire [8:0] mix_rdx1out;
	wire [8:0] mix_rdx2out;
	wire [9:0] mix_rdx3out;

	wire [17:0] mult512out;
	wire [26:0] mult513out;
	mix_rdx mix1 (mix_rdx1out, mix_rdx2out, mix_rdx3out, x1, x2, x3, clk);
	mult512 m512 (mult512out, mix_rdx2out);
	mult513 m513 (mult513out, mix_rdx3out);
	par_adder pa (result, mix_rdx1out, mult512out, mult513out, clk);

endmodule

module atest_bench();
	reg clk;
	reg [8:0] in0;  // Module: 511
	reg [9:0] in1;  // Module: 512
	reg [9:0] in2;  // Module: 513
	wire [26:0] out; // Max value (not included): 134217216

	integer l;
	reg dummy;
	integer i0, prev;

	reverse_conv r1 (out, in0, in1, in2, clk);

	// One test. Ticks: 3
	initial
	begin
		i0 = 21614413;
		clk = 0;
		#1 dummy = 1;
		in0 = i0%511;
		in1 = i0%512;
		in2 = i0%513;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		$display ("!!! Res=(%d) Expect=(%d)", out, i0);
		l = out;
		if (l != i0)
		begin
			$display ("!!! Error (%d, %d)!!!", i0, l);
		end
	end
endmodule
