module lut_3_5(out, a, b, clk);
	parameter widtha = 2;
	parameter widthb = 3;
	input [widtha-1:0] a;
	input [widthb-1:0] b;
	input clk;
	output reg [widthb-1:0] out;
	
	always @ (posedge clk) 
	begin 

	case(b) 
	0: begin 
		case(a)
		0: out <= 0;
		1: out <= 3;
		2: out <= 1;
		default: out <= 0; 
		endcase
	end 
	1: begin 
		case(a)
		0: out <= 2;
		1: out <= 0;
		2: out <= 3;
		default: out <= 0; 
		endcase
	end 
	2: begin 
		case(a)
		0: out <= 4;
		1: out <= 2;
		2: out <= 0;
		default: out <= 0; 
		endcase
	end 
	3: begin 
		case(a)
		0: out <= 1;
		1: out <= 4;
		2: out <= 2;
		default: out <= 0; 
		endcase
	end 
	4: begin 
		case(a)
		0: out <= 3;
		1: out <= 1;
		2: out <= 4;
		default: out <= 0; 
		endcase
	end 
	default: out <= 0;
	endcase 
	end
endmodule

module lut_3_7(out, a, b, clk);
	parameter widtha = 2;
	parameter widthb = 3;
	input [widtha-1:0] a;
	input [widthb-1:0] b;
	input clk;
	output reg [widthb-1:0] out;
	
	always @ (posedge clk) 
	begin 

	case(b) 
	0: begin 
		case(a)
		0: out <= 0;
		1: out <= 2;
		2: out <= 4;
		default: out <= 0; 
		endcase
	end 
	1: begin 
		case(a)
		0: out <= 5;
		1: out <= 0;
		2: out <= 2;
		default: out <= 0; 
		endcase
	end 
	2: begin 
		case(a)
		0: out <= 3;
		1: out <= 5;
		2: out <= 0;
		default: out <= 0; 
		endcase
	end 
	3: begin 
		case(a)
		0: out <= 1;
		1: out <= 3;
		2: out <= 5;
		default: out <= 0; 
		endcase
	end 
	4: begin 
		case(a)
		0: out <= 6;
		1: out <= 1;
		2: out <= 3;
		default: out <= 0; 
		endcase
	end 
	5: begin 
		case(a)
		0: out <= 4;
		1: out <= 6;
		2: out <= 1;
		default: out <= 0; 
		endcase
	end 
	6: begin 
		case(a)
		0: out <= 2;
		1: out <= 4;
		2: out <= 6;
		default: out <= 0; 
		endcase
	end 
	default: out <= 0;
	endcase 
	end
endmodule

module lut_5_7(out, a, b, clk);
	parameter widtha = 3;
	parameter widthb = 3;
	input [widtha-1:0] a;
	input [widthb-1:0] b;
	input clk;
	output reg [widthb-1:0] out;
	
	always @ (posedge clk) 
	begin 

	case(b) 
	0: begin 
		case(a)
		0: out <= 0;
		1: out <= 4;
		2: out <= 1;
		3: out <= 5;
		4: out <= 2;
		default: out <= 0; 
		endcase
	end 
	1: begin 
		case(a)
		0: out <= 3;
		1: out <= 0;
		2: out <= 4;
		3: out <= 1;
		4: out <= 5;
		default: out <= 0; 
		endcase
	end 
	2: begin 
		case(a)
		0: out <= 6;
		1: out <= 3;
		2: out <= 0;
		3: out <= 4;
		4: out <= 1;
		default: out <= 0; 
		endcase
	end 
	3: begin 
		case(a)
		0: out <= 2;
		1: out <= 6;
		2: out <= 3;
		3: out <= 0;
		4: out <= 4;
		default: out <= 0; 
		endcase
	end 
	4: begin 
		case(a)
		0: out <= 5;
		1: out <= 2;
		2: out <= 6;
		3: out <= 3;
		4: out <= 0;
		default: out <= 0; 
		endcase
	end 
	5: begin 
		case(a)
		0: out <= 1;
		1: out <= 5;
		2: out <= 2;
		3: out <= 6;
		4: out <= 3;
		default: out <= 0; 
		endcase
	end 
	6: begin 
		case(a)
		0: out <= 4;
		1: out <= 1;
		2: out <= 5;
		3: out <= 2;
		4: out <= 6;
		default: out <= 0; 
		endcase
	end 
	default: out <= 0;
	endcase 
	end
endmodule

module mult5(out, data);

	input [2:0] data;
	output reg [3:0] out;
	
	always @ (data) 
	begin
	case(data) 
		0: out <= 0;
		1: out <= 3;
		2: out <= 6;
		3: out <= 9;
		4: out <= 12;
		default: out <= 0;
	endcase 
	end
endmodule

module mult7(out, data);

	input [2:0] data;
	output reg [6:0] out;
	
	always @ (data) 
	begin
	case(data) 
		0: out <= 0;
		1: out <= 15;
		2: out <= 30;
		3: out <= 45;
		4: out <= 60;
		5: out <= 75;
		6: out <= 90;
		default: out <= 0;
	endcase 
	end
endmodule

module register(res, x, clk);
	parameter WIDTH=3;
	input  clk;
	input  [WIDTH-1:0] x;
	output reg [WIDTH-1:0] res;

	always @ (posedge clk)
	begin
		res <= x;
	end
endmodule

module adder(result, dataa, datab, clk);
	parameter WIDTH_A=3;
	parameter WIDTH_B=8;
	input clk;
	input  [WIDTH_A - 1:0] dataa;
	input  [WIDTH_B - 1:0] datab;
	output reg [WIDTH_B:0] result;

	always @ (posedge clk) 
	begin 
		result <= dataa + datab;
	end
endmodule

module mix_rdx (res1, res2, res3, x1, x2, x3, clk); 

	input clk;
	input	[1:0] x1;
	input	[2:0] x2;
	input	[2:0] x3;

	output	[1:0] res1;
	output	[2:0] res2;
	output	[2:0] res3;
	
	wire [2:0] out_3_7;

	assign res1 = x1;

	lut_3_5 l3_5 (res2, x1, x2, clk);
	lut_3_7 l3_7 (out_3_7, x1, x3, clk);
	lut_5_7 l5_7 (res3, res2, out_3_7, clk);
endmodule

module par_adder(result, x1, x2, x3, clk);

	input clk;
	input [1:0] x1;
	input [3:0] x2;
	input [6:0] x3;
	output [7:0] result;
	wire [1:0] reg1out;
	wire [4:0] add1out;

	register #(.WIDTH(2)) reg1 (reg1out, x1, clk);
	adder #(.WIDTH_A(2), .WIDTH_B(4)) add1 (add1out, reg1out, x2, clk);
	adder #(.WIDTH_A(5), .WIDTH_B(7)) add2 (result, add1out, x3, clk);
endmodule

module reverse_conv(result, x1, x2, x3, clk);

	input clk;
	input [1:0] x1;
	input [2:0] x2;
	input [2:0] x3;
	output [7:0] result;

	wire [1:0] mix_rdx1out;
	wire [2:0] mix_rdx2out;
	wire [2:0] mix_rdx3out;

	wire [3:0] mult5out;
	wire [6:0] mult7out;
	mix_rdx mix1 (mix_rdx1out, mix_rdx2out, mix_rdx3out, x1, x2, x3, clk);
	mult5 m5 (mult5out, mix_rdx2out);
	mult7 m7 (mult7out, mix_rdx3out);
	par_adder pa (result, mix_rdx1out, mult5out, mult7out, clk);

endmodule

module atest_bench();
	reg clk;
	reg [1:0] in0;  // Module: 3
	reg [2:0] in1;  // Module: 5
	reg [2:0] in2;  // Module: 7
	wire [6:0] out; // Max value (not included): 105

	integer l;
	reg dummy;
	integer i0, prev;

	reverse_conv r1 (out, in0, in1, in2, clk);

	// One test. Ticks: 3
	initial
	begin
	// Main cycle
	for (i0 = 0; i0 < 105; i0 = i0+1)
	begin
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		in0 = i0%3;
		in1 = i0%5;
		in2 = i0%7;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		// Value for check (based on length of pipeline)
		prev = i0-3+1; 
		if (prev >= 0)
		begin
			$display ("!!! Res=(%d) Expect=(%d)", out, prev);
			l = out;
			if (l != prev)
			begin
				$display ("!!! Error (%d, %d)!!!", prev, l);
			end
		end
	end
	// Last data on pipeline
	for (i0 = 105; i0 < 105 + 3 - 1; i0 = i0+1)
	begin
		#1 dummy = 1;
		clk = 0;
		#1 dummy = 1;
		clk = 1;
		#1 dummy = 1;
		// Value for check
		prev = i0-3+1; 
		$display ("!!! Res=(%d) Expect=(%d)", out, prev);
		l = out;
		if (l != prev)
		begin
			$display ("!!! Error (%d, %d)!!!", prev, l);
		end
	end
	end
endmodule
