<?
	require_once($_SERVER['DOCUMENT_ROOT']."/inc/interface.php");
	print_header("Генератор Verilog конвеерного обратного преобразователя на базе полиадического кода", "Генератор Verilog конвеерного обратного преобразователя на базе полиадического кода");
	
	function find_bit($p) {
		$k = '1';
		$p = "$p";
		for ($i = 0; $i < 1024; $i++) {
			if (gmp_cmp($k, $p) > 0)
				return $i;
			$k = gmp_mul($k, '2');
		}
		return -1;
	}
	
	function pow2($p) {
		return gmp_strval(gmp_pow(2, $p));
	}
	
	function syntax_dec_number($num) {
		$bt = find_bit($num);
		return "$bt'd$num";
	}
	
	function extended_euclid($a, $b, &$x, &$y, &$d) {
		if ($b == 0) {
			$d = $a;
			$x = 1;
			$y = 0;
			return;
		}
		$x2 = 1; 
		$x1 = 0; 
		$y2 = 0; 
		$y1 = 1;
		while ($b > 0) {
			$q = floor($a / $b);
			$r = $a - $q * $b;
			$x = $x2 - $q * $x1;
			$y = $y2 - $q * $y1;
			$a = $b;
			$b = $r;
			$x2 = $x1;
			$x1 = $x;
			$y2 = $y1;
			$y1 = $y;
		}
		$d = $a;
		$x = $x2;
		$y = $y2;
	}
	
	function find_inverse($a, $n) {
		extended_euclid($a, $n, $x, $y, $d);
		if ($d == 1) {
			if ($x < 0)
				return $x + $n;
			else
				return $x;
		}
		return 0;
	}

	function lut ($p1, $p2) {
		$widtha = find_bit($p1);
		$widthb = find_bit($p2);
		$i = 0;
		$j = 0;

		print "module lut_".$p1."_".$p2."(out, a, b, clk);\n";
		print "	parameter widtha = $widtha;\n";
		print "	parameter widthb = $widthb;\n";
		print "	input [widtha-1:0] a;\n";
		print "	input [widthb-1:0] b;\n";
		print "	input clk;\n";
		print "	output reg [widthb-1:0] out;\n";
		print "	\n";
		print "	always @ (posedge clk) \n";
		print "	begin \n";
		print "\n";
		print "	case(b) \n";
		for ($j = 0; $j < $p2; $j++)
		{
			print "	$j: begin \n";
			print "		case(a)\n";
			for ($i = 0; $i < $p1; $i++)
			{
				$temp = ((($j - $i + $p2)%$p2)*find_inverse($p1, $p2))%$p2;
				print "		$i: out <= $temp;\n";
			}
			print "		default: out <= 0; \n";
			print "		endcase\n";
			print "	end \n";
		}
		print "	default: out <= 0;\n";
		print "	endcase \n";
		print "	end\n";
		print "endmodule\n\n";
	}
	
	// max_val - достигается
	function print_integer_mod_value_and_max_val($mod, $max_val) {
		global $check_arr;
	
		$mod = gmp_strval("$mod");
		$max_val = gmp_strval("$max_val");
			
		// Убеждаемся что такое мы ещё не печатали
		if (isset($check_arr[$mod][$max_val]))
			return;
		$check_arr[$mod][$max_val] = 1;
	
		$inbit = find_bit($max_val);
		$outbit = find_bit(gmp_strval(gmp_sub($mod, 1)));
		echo "module mod_".gmp_strval($mod)."_".gmp_strval($max_val)." (in, out);\n";
		echo "	input [".($inbit-1).":0] in;\n";
		echo "	output reg [".($outbit-1).":0] out;\n";
		
		echo "	always @ (in)\n";
		echo "	begin\n";
		if (gmp_cmp($max_val, 100) < 0 && 0)
		{
			
			echo "	// we have small max value so we can use table here\n";
			echo "	case (in)\n";
			for ($i = 0; $i <= gmp_strval($max_val); $i++) {
				echo "		$i: out = ".(gmp_strval(gmp_mod($i, $mod))).";\n";
			}
			echo "		default: out = 0;\n";
			echo "	endcase\n";
		}
		else
		{
			echo "		if (in < ".syntax_dec_number(gmp_strval($mod)).")\n";
				echo "		begin\n";
				echo "			out = in;\n";
				echo "		end\n";
			for ($i = gmp_mul(2, $mod); gmp_cmp($i, $max_val) <= 0; $i = gmp_add($i, $mod)) {
				echo "		else if (in < ".syntax_dec_number(gmp_strval($i)).")\n";
				echo "		begin\n";
				echo "			out = in - ".syntax_dec_number(gmp_strval(gmp_sub($i, $mod))).";\n";
				echo "		end\n";
			}
			echo "		else\n";
			echo "		begin\n";
			echo "			out = in - ".syntax_dec_number(gmp_strval(gmp_sub($i, $mod))).";\n";
			echo "		end\n";
		}
		echo "	end\n";
		echo "endmodule\n\n";
	}
	
	function pipestep ($p1, $p2) {
		$widtha = find_bit($p1);
		$widthb = find_bit($p2);

		$inverted = find_inverse($p1, $p2);
		$max_val = 0;
		for ($i = 0; $i < $widthb; $i++) {
			$max_val += ($inverted*pow2($i))%$p2;
		}
		$widthc = find_bit($max_val+1);
		
		print "module lut_".$p1."_".$p2."(out, a, b, clk);\n";
		print "	input [".($widtha-1).":0] a;\n";
		print "	input [".($widthb-1).":0] b;\n";
		print "	reg [".($widthb-1).":0] inter;\n";
		print "	wire [".($widthc-1).":0] bmod;\n";
		print "	input clk;\n";
		print "	output wire [".($widthb-1).":0] out;\n\n";
		
		print "	assign bmod = $inverted*inter[0]";
		for ($i = 1; $i < $widthb; $i++) {
			print " + ".($inverted*pow2($i))%$p2."*inter[$i]";
		}
		print ";\n";
		
		print "	mod_".gmp_strval($p2)."_".gmp_strval($max_val)." mod (bmod, out);\n";
		
		print "	\n";
		print "	always @ (posedge clk) \n";
		print "	begin \n";
		print "\n";
		
		print "		if (b >= a)\n";
		print "		begin \n";
		print "			inter = b - a;\n";
		print "		end \n";
		print "		else \n";
		print "		begin \n";
		print "			inter = $p2 + b - a;\n";
		print "		end \n";
				
		print "	end\n";
		print "endmodule\n\n";
		print_integer_mod_value_and_max_val($p2, $max_val);
	}
	
	function mult_lut ($mod, $koeff) {
		$widtha = find_bit($mod-1);
		$widthb = find_bit($koeff*($mod-1));

		print "module mult".$mod."(out, data);\n";
		print "\n";
		print "	input [".($widtha-1).":0] data;\n";
		print "	output reg [".($widthb-1).":0] out;\n";
		print "	\n";
		print "	always @ (data) \n";
		print "	begin\n";
		print "	case(data) \n";
			  for ($i = 0; $i < $mod; $i++)
			  {
			  print "		".$i.": out <= ".($i*$koeff).";\n";
			  }
		print "		default: out <= 0;\n";
		print "	endcase \n";
		print "	end\n";
		print "endmodule\n\n";
	}
	
	function mult_strict ($mod, $koeff) {
		$widtha = find_bit($mod-1);
		$widthb = find_bit($koeff*($mod-1));

		print "module mult".$mod."(out, data);\n";
		print "\n";
		print "	input [".($widtha-1).":0] data;\n";
		print "	output reg [".($widthb-1).":0] out;\n";
		print "	\n";
		print "	always @ (data) \n";
		print "	begin\n";
		print "		out <= $koeff*data;\n";
		print "	end\n";
		print "endmodule\n\n";
	}
	
	function register() {
		print "module register(res, x, clk);\n";
		print "	parameter WIDTH=3;\n";
		print "	input  clk;\n";
		print "	input  [WIDTH-1:0] x;\n";
		print "	output reg [WIDTH-1:0] res;\n";
		print "\n";
		print "	always @ (posedge clk)\n";
		print "	begin\n";
		print "		res <= x;\n";
		print "	end\n";
		print "endmodule\n\n";
	}
	
	function adder() {
		print "module adder(result, dataa, datab, clk);\n";
		print "	parameter WIDTH_A=3;\n";
		print "	parameter WIDTH_B=8;\n";
		print "	parameter WIDTH_C=8;\n";
		print "	input clk;\n";
		print "	input  [WIDTH_A - 1:0] dataa;\n";
		print "	input  [WIDTH_B - 1:0] datab;\n";
		print "	output reg [WIDTH_C:0] result;\n";
		print "\n";
		print "	always @ (posedge clk) \n";
		print "	begin \n";
		print "		result <= dataa + datab;\n";
		print "	end\n";
		print "endmodule\n\n";
	}

	function mix_rdx($size, $mod) {
		for ($i = 0; $i < $size; $i++) {
			$width[$i] = find_bit($mod[$i]-1);
		}

		print "module mix_rdx (";
		for ($i=1; $i<$size+1; $i++)
		{
			print "res".$i.", ";
		}
		for ($i=1; $i<$size+1; $i++)
		{
			print "x".$i.", ";
		}
		print "clk); \n";
		print "\n";
		print "	input clk;\n";
		for ($i=1; $i<$size+1; $i++)
		{
			print "	input	[".($width[$i-1]-1).":0] x".$i.";\n";
		}
		print "\n";
		for ($i=1; $i<$size+1; $i++)
		{
			print "	output	[".($width[$i-1]-1).":0] res".$i.";\n";
		}
		print "	\n";

		for ($i=$size-1; $i >= 2; $i--)
		{
			print "	wire [".($width[$i]-1).":0] ";
			for ($j = $i-2; $j > 0; $j--)
			{
				print "out_".$mod[$j]."_".$mod[$i].", ";
			}
			print "out_".$mod[0]."_".$mod[$i].";\n";
		}

		print "\n";
		print "	assign res1 = x1;\n";
		print "\n";

		for ($i = 0; $i < $size; $i++)
		{
			for ($j = $i+1; $j < $size; $j++)
			{
				print "	lut_".$mod[$i]. "_". $mod[$j]. " l". $mod[$i]. "_". $mod[$j]. " (";
				if ($j==$i+1) {print "res".($i+2).", ";} else {print "out_".$mod[$i]. "_". $mod[$j]. ", ";}
				if ($i==0) {print "x1, x".($j+1).", ";} else {print "res".($i+1).", out_".$mod[$i-1]."_".$mod[$j].", ";}
				print "clk);\n";
			}
		}

		print "endmodule\n\n";
	}
	
	
	function par_add($size, $mod) {
		$koeff[0] = 1;

		$temp = 1;
		for ($i = 0; $i < $size-1; $i++)
		{
			$temp = $temp*$mod[$i];
			$koeff[$i+1] = $temp;
		}

		for ($i = 0; $i < $size; $i++)
		{
			$width[$i] = find_bit($koeff[$i]*($mod[$i]-1));
		}

		print "module par_adder(result, ";

		for ($i = 1; $i <= $size; $i++)
		{
			print "x".$i.", ";
		}
		print "clk);\n";
		print "\n";
		print "	input clk;\n";
		for ($i = 1; $i < $size+1; $i++)
		{
			print "	input [".($width[$i-1]-1).":0] x".$i.";\n";
		}

		print "	output [".(($width[$size-1])-1).":0] result;\n";
		print "	wire [".($width[0]-1).":0] reg1out;\n";
		for ($i = 1; $i < $size-1; $i++)
		{
			print "	wire [".($width[$i]).":0] add".$i."out;\n";
		}
		print "\n";
		print "	register #(.WIDTH(".$width[0].")) reg1 (reg1out, x1, clk);\n";
		print "	adder #(.WIDTH_A(".($width[0])."), .WIDTH_B(".($width[1])."), .WIDTH_C(".($width[1]).")) add1 (add1out, reg1out, x2, clk);\n";
		for ($i = 2; $i < $size-1; $i++)
		{
			print "	adder #(.WIDTH_A(".($width[$i-1]+1)."), .WIDTH_B(".$width[$i]."), .WIDTH_C(".$width[$i].")) add".$i." (add".$i."out, add".($i-1)."out, x".($i+1).", clk);\n";
		}
		print "	adder #(.WIDTH_A(".($width[$size-2]+1)."), .WIDTH_B(".$width[$size-1]."), .WIDTH_C(".(($width[$size-1])-1).")) add".($size-1)." (result, add".($size-2)."out, x".$size.", clk);\n";
		
		print "endmodule\n\n";
	}

	function reverse ($size, $mod) {

		for ($i = 0; $i < $size; $i++) {
			$inp_width[$i] = find_bit($mod[$i]-1);
		}

		$koeff[0] = 1;
		$temp = 1;
		for ($i = 0; $i < $size-1; $i++)
		{
			$temp = $temp*$mod[$i];
			$koeff[$i+1] = $temp;
		}

		for ($i = 0; $i < $size; $i++)
		{
			$width[$i] = find_bit($koeff[$i]*($mod[$i]-1));
		}

		print "module reverse_conv(result, ";
		for ($i = 1; $i < $size+1; $i++)
		{
			print "x".$i.", ";
		}
		print "clk);\n";
		print "\n";
		print "	input clk;\n";
		for ($i = 1; $i < $size+1; $i++)
		{
			print "	input [".($inp_width[$i-1]-1).":0] x".$i.";\n";
		}
		print "	output [".(($width[$size-1])-1).":0] result;\n";
		print "\n";
		for ($i = 1; $i < $size+1; $i++)
		{
			print "	wire [".($inp_width[$i-1]-1).":0] mix_rdx".$i."out;\n";
		}
		print "\n";
		for ($i = 2; $i < $size+1; $i++)
		{
			print "	wire [".($width[$i-1]-1).":0] mult".$mod[$i-1]."out;\n";
		}

		print "	mix_rdx mix1 (";
		for ($i = 1; $i < $size+1; $i++)
		{
			print "mix_rdx".$i."out, ";
		}
		for ($i = 1; $i < $size+1; $i++)
		{
			print "x".$i.", ";
		}
		print "clk);\n";
		for ($i = 2; $i < $size+1; $i++)
		{
			print "	mult".$mod[$i-1]." m".$mod[$i-1]." (mult".$mod[$i-1]."out, mix_rdx".$i."out);\n";
		}
		
		print "	par_adder pa (result, mix_rdx1out, ";
		for ($i = 2; $i < $size+1; $i++)
		{
			print "mult".$mod[$i-1]."out, ";
		}
		print "clk);\n";
		
		print "\n";
		print "endmodule\n\n";
	}
	
	function print_test_bench_seq($dynamic, $size, $mod) {
	
		echo "module atest_bench();\n";
					
		echo "	reg clk;\n";
		for ($i = 0; $i < $size; $i++) {
			$bit = find_bit($mod[$i])-1;
			echo "	reg [$bit:0] in$i;  // Module: ".$mod[$i]."\n";
		}
		$outbit = find_bit($dynamic)-1;
		echo "	wire [$outbit:0] out; // Max value (not included): $dynamic\n\n";
				
		echo "	integer l;\n";
		echo "	reg dummy;\n";
		echo "	integer i0, prev;\n";
		echo "\n";
		
		echo "	reverse_conv r1 (out, ";
		for ($i = 0; $i < $size; $i++) {
			echo "in$i, ";
		}
		echo "clk);\n\n";
			
		echo "	// One test. Ticks: $size\n";
			
		echo "	initial\n";
		echo "	begin\n";
		
		if ($dynamic > 10000) {
			echo "		i0 = ".rand(0, $dynamic-1).";\n";
			echo "		clk = 0;\n";
			echo "		#1 dummy = 1;\n";
			for ($i = 0; $i < $size; $i++) {
				echo "		in$i = i0%".$mod[$i].";\n";
			}
			echo "		#1 dummy = 1;\n";
			echo "		clk = 1;\n";
			for ($i = 0; $i < $size; $i++) {
				echo "		#1 dummy = 1;\n";
				echo "		clk = 0;\n";
				echo "		#1 dummy = 1;\n";
				echo "		clk = 1;\n";
			}
			echo "		\$display (\"!!! Res=(%d) Expect=(%d)\", out, i0);\n";
			echo "		l = out;\n";
			echo "		if (l != i0)\n";
			echo "		begin\n";
			echo "			\$display (\"!!! Error (%d, %d)!!!\", i0, l);\n";
			echo "		end\n";
		} else {
			echo "	// Main cycle\n";
			echo "	for (i0 = 0; i0 < $dynamic; i0 = i0+1)\n";
			echo "	begin\n";
			echo "		#1 dummy = 1;\n";
			echo "		clk = 0;\n";
			echo "		#1 dummy = 1;\n";
			for ($i = 0; $i < $size; $i++) {
				echo "		in$i = i0%".$mod[$i].";\n";
			}
			echo "		#1 dummy = 1;\n";
			echo "		clk = 1;\n";
			echo "		#1 dummy = 1;\n";
			echo "		// Value for check (based on length of pipeline)\n";
			echo "		prev = i0-$size+1; \n";
			echo "		if (prev >= 0)\n";
			echo "		begin\n";
			echo "			\$display (\"!!! Res=(%d) Expect=(%d)\", out, prev);\n";
			echo "			l = out;\n";
			echo "			if (l != prev)\n";
			echo "			begin\n";
			echo "				\$display (\"!!! Error (%d, %d)!!!\", prev, l);\n";
			echo "			end\n";
			echo "		end\n";
			echo "	end\n";
			
			echo "	// Last data on pipeline\n";
			echo "	for (i0 = $dynamic; i0 < $dynamic + $size - 1; i0 = i0+1)\n";
			echo "	begin\n";
			echo "		#1 dummy = 1;\n";
			echo "		clk = 0;\n";
			echo "		#1 dummy = 1;\n";
			echo "		clk = 1;\n";
			echo "		#1 dummy = 1;\n";
			echo "		// Value for check\n";
			echo "		prev = i0-$size+1; \n";
			echo "		\$display (\"!!! Res=(%d) Expect=(%d)\", out, prev);\n";
			echo "		l = out;\n";
			echo "		if (l != prev)\n";
			echo "		begin\n";
			echo "			\$display (\"!!! Error (%d, %d)!!!\", prev, l);\n";
			echo "		end\n";
			echo "	end\n";
		}
		echo "	end\n";
		echo "endmodule\n";
	}
	
?>
<form>
<div style="margin-top: 10px;">
Введите набор модулей через пробел:
<input style="width: 300px" class="element select medium" id="modules" name="modules" value="<?
if (isset($_GET['modules']))
	echo trim($_GET['modules']);
else
	echo "7 5 3";
?>"> 
</div>
<div style="margin-top: 10px;">
Использовать таблицы (LUT) для операций
<input type="checkbox" name="usetables" <? if (isset($_GET['usetables'])) echo "checked"?> >
</div>
<div style="margin-top: 10px;">
<input type="submit" value="Сгенерировать" />
</div>
</form>

<div>* - Модули должны быть взаимнопросты</div>
<div>* - Если данные выйдут за 32 бита, корректность пока не гарантируется</div>
<?
if (isset($_GET['modules']) && $_GET['modules'] != '')
	$mod = explode(" ", trim($_GET['modules']));
else
	$mod = array(7, 5, 3);
	
	sort($mod);
	
	$usetables = 0;
	if (isset($_GET['usetables']))
		$usetables = 1;
		
	$dynamic = 1;
	$size = 0;
	echo "<BR>\nНабор модулей: ";
	foreach ($mod as $m) {
		$dynamic *= $m;
		$size++;
		echo " $m";
	}
	echo "<BR>\n";

	#Podschet koeff. umnojeniya
	$koeff[0] = 1;
	$temp = 1;
	for ($i = 0; $i < $size-1; $i++)
	{
		$temp = $temp*$mod[$i];
		$koeff[($i+1)] = $temp;
	}
	echo "Набор коэффициентов: ";
	for ($i = 0; $i < $size; $i++) {
		echo $koeff[$i]." ";
	}
	echo "<BR>\n";
		
	echo "<textarea style=\"width: 900px; height: 800px; margin-top: 15px;\" readonly>";

	# ----------------- sozdanie lut-ov -------------------
	for ($f = 0; $f < $size; $f++)
	{
		for ($s = $f+1; $s < $size; $s++)
		{
			// echo $mod[$f], "  ", $mod[$s], "\n";
			if ($usetables == 1)
				lut($mod[$f], $mod[$s]);
			else
				pipestep($mod[$f], $mod[$s]);
		}
	}
	
	# ----------------- sozdanie umnozitelei ------------------
	$temp = 1;
	for ($z = 0; $z < $size-1; $z++)
	{
		$temp = $temp*$mod[$z];
		if ($usetables == 1)
			mult_lut($mod[$z+1], $temp);
		else
			mult_strict($mod[$z+1], $temp);
	}
	
	register();
	adder();
	mix_rdx($size, $mod);
	par_add($size, $mod);
	reverse($size, $mod);
	print_test_bench_seq($dynamic, $size, $mod);
	
	echo "</textarea>";
?>
<BR><BR><b>Описание</b>: <BR>
1. Испольуется подход на базе <a href=http://vscripts.ru/w/%D0%9F%D0%BE%D0%BB%D0%B8%D0%B0%D0%B4%D0%B8%D1%87%D0%B5%D1%81%D0%BA%D0%B8%D0%B9_%D0%BA%D0%BE%D0%B4>полиадического кода</a><BR>
2. Количество тактов для расчета равно количеству модулей<BR>
<BR>
<?
print_footer(); 
?>
